//
//   Copyright 2011 Gynvael Coldwind & Mateusz "j00ru" Jurczyk
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <map>
#include <string>
#include <SDL/SDL_mixer.h>
using namespace std;

#define SND_DENY     ("deny")
#define SND_SHOOT    ("shoot")
#define SND_HIT      ("hit")
#define SND_DOOR     ("door")
#define SND_MENU_CHANGE ("menu_change")
#define SND_MENU_SELECT ("menu_select")
#define SND_SUCCESS  ("success")
#define SND_TELEPORT ("teleport")
#define SND_FAILURE  ("failure")

extern map<string, Mix_Music*> g_MusicContainer;
extern map<string, Mix_Chunk*> g_SoundContainer;

bool music_Init();
bool music_AddSound(char* filename, char* name);
bool music_AddMusic(char* filename, char* name);
void music_playSound(char* name);
void music_playMusic(char* name);
void music_Stop();

bool music_SoundsExists(char* name);
bool music_MusicExists(char* name);

