//
//   Copyright 2011 Gynvael Coldwind & Mateusz "j00ru" Jurczyk
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#pragma once
#include <stdint.h>

#define PLAYER_SPEED 10.0f
#define PLAYER_SIZE  0.5f
#define HALF_PLAYER_SIZE (PLAYER_SIZE / 2.0f)

#define PLAYER_TYPE_ONE 0
#define PLAYER_TYPE_TWO 1
#define PLAYER_TYPE_THREE 2
#define PLAYER_TYPE_FOUR 3

typedef struct tagPLAYER_STRUCT
{
  float x, y;
  int params[3];

  unsigned int pos;
  int map;
} PLAYER_STRUCT;


// Player functions
void player_InitGameState();
void player_InitializeXY();
void player_InitializeAllXY();
void player_UpdatePosition();
void player_HandleSpells();
void player_HandleSpecialLocations();
void player_RenderAll();

